## qgis 3.22.10+dfsg

=== CMakeLists.txt ===
#############################################################
# CMake settings
cmake_minimum_required(VERSION 3.12.0)
set(CMAKE_COLOR_MAKEFILE ON)
set(CMAKE_AUTORCC ON)
# set path to additional CMake modules
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})
# POLICIES
cmake_policy(SET CMP0048 NEW)
cmake_policy(SET CMP0053 NEW)
cmake_policy(SET CMP0071 NEW)
cmake_policy(SET CMP0094 NEW)

# don't relink it only the shared object changes
set(CMAKE_LINK_DEPENDS_NO_SHARED ON)

#############################################################
# Project and version
set(CPACK_PACKAGE_VERSION_MAJOR "3")
set(CPACK_PACKAGE_VERSION_MINOR "22")
set(CPACK_PACKAGE_VERSION_PATCH "10")
set(COMPLETE_VERSION ${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH})
set(RELEASE_NAME "Białowieża")
project(qgis VERSION ${COMPLETE_VERSION})

if (APPLE)
  set(QGIS_APP_NAME "QGIS")
else()
  set(QGIS_APP_NAME "qgis")
endif()

# Note the version no is Mmmpp for Major/minor/patch, 0-padded, thus '10100' for 1.1.0
math(EXPR QGIS_VERSION_INT "${CPACK_PACKAGE_VERSION_MAJOR}*10000+${CPACK_PACKAGE_VERSION_MINOR}*100+${CPACK_PACKAGE_VERSION_PATCH}")
message(STATUS "QGIS version: ${COMPLETE_VERSION} ${RELEASE_NAME} (${QGIS_VERSION_INT})")

set (ENABLE_LOCAL_BUILD_SHORTCUTS FALSE CACHE BOOL "Disables some build steps which are only relevant for releases to speed up compilation time for development")

#############################################################
if (APPLE)
  # QGIS custom dependencies package from qgis/QGIS-Mac-Packager
  # they can be downloaded from https://qgis.org/downloads/macos/qgis-deps
  # and extracted to /opt/QGIS/qgis-deps-<deps-version>/stage
  set (QGIS_MAC_DEPS_DIR "" CACHE PATH "Path to QGIS Mac custom dependencies directory")

  # Setup LIB_DIR and CMAKE_PREFIX_PATH to help CMake's
  # find_packages to look for these libraries instead of system libraries
  if ( QGIS_MAC_DEPS_DIR )
    set(ENV{LIB_DIR} ${QGIS_MAC_DEPS_DIR})
    list(APPEND CMAKE_PREFIX_PATH ${QGIS_MAC_DEPS_DIR})
  endif()
endif()

#############################################################
# Configure OpenCL if available
set(HAVE_OPENCL FALSE)
if (${CMAKE_HOST_SYSTEM_NAME} MATCHES "BSD$")
  option(USE_OPENCL "Use OpenCL" OFF)
else()
  option(USE_OPENCL "Use OpenCL" ON)
endif()
if (USE_OPENCL)
    find_package(OpenCL)
    if(${OpenCL_FOUND})
        set(HAVE_OPENCL TRUE)
        # Fixup for standard FindOpenCL module not assigning proper framework headers directory
        if (APPLE AND "${OpenCL_INCLUDE_DIR}" MATCHES "OpenCL\\.framework/?$")
            set(OpenCL_INCLUDE_DIR "${OpenCL_INCLUDE_DIR}/Headers" CACHE PATH "" FORCE)
            set(OpenCL_INCLUDE_DIRS ${OpenCL_INCLUDE_DIR})
        endif()
        find_package(OpenCLhpp)
        if(NOT OPENCL_HPP_FOUND)
            # Use internal headers copied from OpenCL-CLHPP project
            set(OPENCL_HPP_INCLUDE_DIR ${CMAKE_SOURCE_DIR}/external/opencl-clhpp/include CACHE PATH "" FORCE)
            message(STATUS "Couldn't find OpenCL C++ headers, using internal: ${OPENCL_HPP_INCLUDE_DIR}")
        endif()
        set(OpenCL_INCLUDE_DIRS ${OpenCL_INCLUDE_DIRS} ${OPENCL_HPP_INCLUDE_DIR})
    else()
        message(STATUS "Couldn't find OpenCL: support DISABLED")
    endif()
endif()

# Configure CCache if available
if(NOT MSVC)
  option(USE_CCACHE "Use ccache" ON)
  if (USE_CCACHE)
    find_program(CCACHE_FOUND ccache)
    if(CCACHE_FOUND)
        set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
        set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
        message(STATUS "ccache found")
    endif(CCACHE_FOUND)
  endif(USE_CCACHE)
endif(NOT MSVC)

if (IOS)
    set (DEFAULT_FORCE_STATIC_LIBS TRUE)
else()
    set (DEFAULT_FORCE_STATIC_LIBS FALSE)
endif()

set (FORCE_STATIC_LIBS ${DEFAULT_FORCE_STATIC_LIBS} CACHE BOOL "Determines whether libraries should be static only")
mark_as_advanced(FORCE_STATIC_LIBS)
if (FORCE_STATIC_LIBS)
  set (LIBRARY_TYPE STATIC)
  # following variable is used in qgsconfig.h
  set (HAVE_STATIC_PROVIDERS TRUE)
else()
  set (LIBRARY_TYPE SHARED)
  unset(HAVE_STATIC_PROVIDERS)
endif()

# in generated makefiles use relative paths so the project dir is moveable
# Note commented out since it cause problems but it would be nice to resolve these and enable
#
# issue is caused by include_directories(${CMAKE_BINARY_DIR}) near the end of this file generating incorrect path
#set (CMAKE_USE_RELATIVE_PATHS ON)

set (WITH_CORE TRUE CACHE BOOL "Determines whether QGIS core should be built.")
mark_as_advanced(WITH_CORE)

if(WITH_CORE)
  # Try to configure and build GRASS plugin by default
  foreach (GRASS_SEARCH_VERSION 7 8)
    # Legacy note:
    # For GRASS 6 there were used cached variables without version suffix so that existing caches didn't have to be reconfigured.
    # Cached variables were: WITH_GRASS, WITH_GRASS7, GRASS_PREFIX, GRASS_PREFIX7, GRASS_INCLUDE_DIR, GRASS_INCLUDE_DIR7
    # Everywhere else each variable has version major appended.
    # Normal variables were: GRASS_FOUND6, GRASS_FOUND7, GRASS_MAJOR_VERSION6, GRASS_MAJOR_VERSION7, etc.
    # In addition there is also GRASS_FOUND, which is TRUE if at least one version of GRASS was found
    set (GRASS_CACHE_VERSION ${GRASS_SEARCH_VERSION})
    set (WITH_GRASS${GRASS_CACHE_VERSION} TRUE CACHE BOOL "Determines whether GRASS ${GRASS_SEARCH_VERSION} plugin should be built")
    if (WITH_GRASS${GRASS_CACHE_VERSION})
      find_package(GRASS ${GRASS_SEARCH_VERSION})
      set (GRASS_PREFIX${GRASS_CACHE_VERSION} ${GRASS_PREFIX${GRASS_SEARCH_VERSION}} CACHE PATH "Path to GRASS ${GRASS_SEARCH_VERSION} base directory")
    endif()
  endforeach (GRASS_SEARCH_VERSION)

  set (WITH_GUI TRUE CACHE BOOL "Determines whether QGIS GUI library (and everything built on top of it) should be built")

  set (WITH_OAUTH2_PLUGIN TRUE CACHE BOOL "Build OAuth2 authentication method plugin")
  if(WITH_OAUTH2_PLUGIN)
    set(HAVE_OAUTH2_PLUGIN TRUE)
  endif()

  set (WITH_AUTH TRUE CACHE BOOL "Determines whether QGIS authentication methods should be built")

  set (WITH_ANALYSIS TRUE CACHE BOOL "Determines whether QGIS analysis library should be built")

  set (WITH_DESKTOP TRUE CACHE BOOL "Determines whether QGIS desktop should be built")

  set (WITH_3D FALSE CACHE BOOL "Determines whether QGIS 3D library should be built")

  set (WITH_QUICK FALSE CACHE BOOL "Determines whether QGIS Quick library should be built")

  set (WITH_QGIS_PROCESS TRUE CACHE BOOL "Determines whether the standalone \"qgis_process\" tool should be built")

  set (NATIVE_CRSSYNC_BIN "" CACHE PATH "Path to a natively compiled synccrsdb binary. If set, crssync will not build but use provided bin instead.")
  mark_as_advanced (NATIVE_CRSSYNC_BIN)

  # try to configure and build python bindings by default
  set (WITH_BINDINGS TRUE CACHE BOOL "Determines whether python bindings should be built")
  if (WITH_BINDINGS)
    # By default bindings will be installed only to QGIS directory
    # Someone might want to install it to python site-packages directory
    # as otherwise user has to use PYTHONPATH environment variable to add
    # QGIS bindings to package search path
    set (BINDINGS_GLOBAL_INSTALL FALSE CACHE BOOL "Install bindings to global python directory? (might need root)")
    set (SIP_GLOBAL_INSTALL FALSE CACHE BOOL "Install sip source files to system sip directory? (might need root)")
    set (WITH_STAGED_PLUGINS TRUE CACHE BOOL "Stage-install core Python plugins to run from build directory? (utilities and console are always staged)")
    set (WITH_PY_COMPILE FALSE CACHE BOOL "Determines whether Python modules in staged or installed locations are byte-compiled")
    # concatenate QScintilla2 API files
    if (WITH_GUI)
      set (WITH_QSCIAPI TRUE CACHE BOOL "Whether to generate PyQGIS QScintilla2 API file. (For devs) run 'make qsci-pap-src' in between QGIS build and install to regenerate .pap file in source tree for console auto-completion.")
      # keep casual users from updating their source tree via WITH_QSCIAPI
      mark_as_advanced (WITH_QSCIAPI)
    endif()
  endif()

  # server disabled default because it needs FastCGI (which is optional dependency)
  set (WITH_SERVER FALSE CACHE BOOL "Determines whether QGIS server should be built")
  if(WITH_SERVER)
    set (SERVER_SKIP_ECW FALSE CACHE BOOL "Determines whether QGIS server should disable ECW (ECW in server apps requires a special license)")

    set (WITH_SERVER_PLUGINS ${WITH_BINDINGS} CACHE BOOL "Determines whether QGIS server support for python plugins should be built")
    if(WITH_SERVER_PLUGINS AND NOT WITH_BINDINGS)
      message(FATAL_ERROR "Server plugins are not supported without python bindings. Enable WITH_BINDINGS or disable WITH_SERVER_PLUGINS")
    endif()
    if(WITH_SERVER_PLUGINS)
      set(HAVE_SERVER_PYTHON_PLUGINS TRUE)
    endif()
  endif()

  # Custom widgets
  set (WITH_CUSTOM_WIDGETS FALSE CACHE BOOL "Determines whether QGIS custom widgets for Qt Designer should be built")

  if (NOT WITH_GUI)
    set (HAVE_GUI FALSE)    # used in qgsconfig.h
    # force value of some options
    if(WITH_DESKTOP)
      message(FATAL_ERROR "Desktop cannot be built without gui. Enable WITH_GUI or disable WITH_DESKTOP.")
    endif()
    if(WITH_CUSTOM_WIDGETS)
      message(FATAL_ERROR "Custom widgets cannot be built without gui. Enable WITH_GUI or disable WITH_CUSTOM_WIDGETS.")
    endif()
  else()
    set (HAVE_GUI TRUE)     # used in qgsconfig.h
  endif()

  if ( WITH_DESKTOP AND NOT WITH_ANALYSIS )
    message(FATAL_ERROR "Desktop cannot be built without analysis")
  endif()

  if ( WITH_QGIS_PROCESS AND NOT WITH_ANALYSIS )
    message(FATAL_ERROR "Process tool cannot be built without analysis")
  endif()

  if ( WITH_DESKTOP )
    # The qgis_desktop target is meant to build a minimal but complete running QGIS during development
    # This should help to reduce compile time while still having a "complete enough" QGIS for most of the development
    add_custom_target(qgis_desktop
      DEPENDS qgis qgispython pycore pygui pyanalysis provider_postgres staged-plugins pyplugin-installer resources svg doc icons
    )
  endif()

  # try to configure and build MDAL support
  set (WITH_INTERNAL_MDAL TRUE CACHE BOOL "Determines whether MDAL should be built from internal copy")
  if (NOT WITH_INTERNAL_MDAL)
    set (MDAL_PREFIX "" CACHE PATH "Path to MDAL base directory")
  endif()

  # try to configure and build POLY2TRI support
  set (WITH_INTERNAL_POLY2TRI TRUE CACHE BOOL "Determines whether POLY2TRI should be built from internal copy")

  # try to configure and build POSTGRESQL support
  set (WITH_POSTGRESQL TRUE CACHE BOOL "Determines whether POSTGRESQL support should be built")
  if (WITH_POSTGRESQL)
    set (POSTGRESQL_PREFIX "" CACHE PATH "Path to POSTGRESQL base directory")
  endif()

  # try to configure and build POSTGRESQL support
  set (WITH_SPATIALITE TRUE CACHE BOOL "Determines whether Spatialite support should be built (required for spatialite, virtual, wfs providers)")
  if (WITH_SPATIALITE)
      set (WITH_QSPATIALITE FALSE CACHE BOOL "Determines whether QSPATIALITE sql driver should be built")
  endif()

  set (WITH_ORACLE FALSE CACHE BOOL "Determines whether Oracle support should be built")
  if(WITH_ORACLE)
    set(HAVE_ORACLE TRUE)
    set(ORACLE_INCLUDEDIR "" CACHE STRING "Path to OCI headers")
    set(ORACLE_LIBDIR "" CACHE STRING "Path to OCI libraries")
  endif()

  set (WITH_HANA FALSE CACHE BOOL "Determines whether SAP HANA Spatial support should be built")
  if(WITH_HANA)
    find_package(ODBC)
    if(ODBC_FOUND)
      set(HAVE_HANA TRUE)
      add_subdirectory(external/odbccpp)
      set_target_properties(odbccpp_static PROPERTIES AUTOMOC OFF AUTOUIC OFF AUTORCC OFF)
    else()
      message(STATUS "Couldn't find ODBC library")
    endif()
  endif(WITH_HANA)

  set (WITH_PDAL FALSE CACHE BOOL "Determines whether PDAL support should be built")
  if(WITH_PDAL)

=== tests/src/gui/CMakeLists.txt ===
# Standard includes and utils to compile into all tests.
set (util_SRCS)

#####################################################
# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(
  ${CMAKE_SOURCE_DIR}/tests/src/core #for render checker class
  ${CMAKE_SOURCE_DIR}/src/test

  ${CMAKE_CURRENT_BINARY_DIR}
)

if(ENABLE_MODELTEST)
  include_directories(${CMAKE_SOURCE_DIR}/tests/qt_modeltest)
endif()

# a simple app for testing GUI of renderers
# These tests are old and are never run so removed for now.
#set(rendererv2gui_SRCS testrenderergui.cpp)
#set(rendererv2gui_HDRS testrenderergui.h)
#add_executable(qgis_rendererv2gui ${rendererv2gui_SRCS} ${rendererv2gui_MOC_SRCS})

#ADD_QGIS_TEST(histogramtest testqgsrasterhistogram.cpp)

set(TESTS
  testqgsannotationitemguiregistry.cpp
  testqgsmaptoolzoom.cpp
  testqgsmaptooledit.cpp
  testqgscategorizedrendererwidget.cpp
  testqgsdatumtransformdialog.cpp
  testqgsdoublespinbox.cpp
  testqgsdualview.cpp
  testqgsattributeform.cpp
  testqgsdatetimeedit.cpp
  testqgsdockwidget.cpp
  testqgsfieldexpressionwidget.cpp
  testqgsfilewidget.cpp
  testqgsexternalstoragefilewidget.cpp
  testqgsfocuswatcher.cpp
  testqgshtmlwidgetwrapper.cpp
  testqgsmapcanvas.cpp
  testqgsmaptoolcapture.cpp
  testqgsmessagebar.cpp
  testprojectionissues.cpp
  testqgsgui.cpp
  testprocessinggui.cpp
  testqgsprocessingmodel.cpp
  testqgsrubberband.cpp
  testqgsscalecombobox.cpp
  testqgsscalerangewidget.cpp
  testqgsrangewidgetwrapper.cpp
  testqgsspinbox.cpp
  testqgssqlcomposerdialog.cpp
  testqgseditorwidgetregistry.cpp
  testqgskeyvaluewidget.cpp
  testqgsfiledownloader.cpp
  testqgslayoutgui.cpp
  testqgslayoutview.cpp
  testqgsvaluemapwidgetwrapper.cpp
  testqgsvaluemapconfigdlg.cpp
  testqgsvaluerelationwidgetwrapper.cpp
  testqgsrelationreferencewidget.cpp
  testqgsfeaturelistcombobox.cpp
  testqgstexteditwrapper.cpp
  testqgstableeditor.cpp
  testqgsnewdatabasetablewidget.cpp
  testqgsogrprovidergui.cpp
  testqgssinglebandpseudocolorrendererwidget.cpp
  testqgsdoublevalidator.cpp
  testqgsmeshlayerpropertiesdialog.cpp
  testqgsexternalresourcewidgetwrapper.cpp
  testqgsquerybuilder.cpp
  testqgsqueryresultwidget.cpp
)

foreach(TESTSRC ${TESTS})
  add_qgis_test( ${TESTSRC} MODULE gui LINKEDLIBRARIES qgis_gui qgis_analysis)
endforeach(TESTSRC)

add_qgis_test(testqgsrasterlayersaveasdialog.cpp MODULE gui LINKEDLIBRARIES qgis_gui qgis_analysis provider_postgres_gui_a)
add_qgis_test(testqgslistwidget.cpp MODULE gui LINKEDLIBRARIES qgis_gui qgis_analysis LABELS "POSTGRES")


if (ENABLE_PGTEST)
  SET_TESTS_PROPERTIES(
    test_gui_processinggui
    test_gui_valuerelationwidgetwrapper
    test_gui_texteditwrapper
    test_gui_newdatabasetablewidget
    test_gui_queryresultwidget
    test_gui_listwidget
    PROPERTIES LABELS "POSTGRES")
endif()

=== tests/src/python/CMakeLists.txt ===
set (ENABLE_MSSQLTEST FALSE CACHE BOOL "Enable MSSQL provider tests")
set (ENABLE_ORACLETEST FALSE CACHE BOOL "Enable Oracle provider tests")
set (ENABLE_HANATEST FALSE CACHE BOOL "Enable HANA provider tests")

include(UsePythonTest)

ADD_PYTHON_TEST(PyQgsDisabledTests test_disabled_tests.py)
ADD_PYTHON_TEST(PyCoreAdditions test_core_additions.py)
ADD_PYTHON_TEST(PyPythonRepr test_python_repr.py)
ADD_PYTHON_TEST(PyPythonUtils test_python_utils.py)
ADD_PYTHON_TEST(PyQgsActionManager test_qgsactionmanager.py)
ADD_PYTHON_TEST(PyQgsAFSProvider test_provider_afs.py)
ADD_PYTHON_TEST(PyQgsAggregateMappingWidget test_qgsaggregatemappingwidget.py)
ADD_PYTHON_TEST(PyQgsAlignmentComboBox test_qgsalignmentcombobox.py)
ADD_PYTHON_TEST(PyQgsArcGisPortalUtils test_qgsarcgisportalutils.py)
ADD_PYTHON_TEST(PyQgsPythonProvider test_provider_python.py)
ADD_PYTHON_TEST(PyQgsAggregateCalculator test_qgsaggregatecalculator.py)
ADD_PYTHON_TEST(PyQgsAnnotation test_qgsannotation.py)
ADD_PYTHON_TEST(PyQgsAnnotationItemEditOperation test_qgsannotationitemeditoperation.py)
ADD_PYTHON_TEST(PyQgsAnnotationItemNode test_qgsannotationitemnode.py)
ADD_PYTHON_TEST(PyQgsAnnotationLayer test_qgsannotationlayer.py)
ADD_PYTHON_TEST(PyQgsAnnotationLineItem test_qgsannotationlineitem.py)
ADD_PYTHON_TEST(PyQgsAnnotationMarkerItem test_qgsannotationmarkeritem.py)
ADD_PYTHON_TEST(PyQgsAnnotationPointTextItem test_qgsannotationpointtextitem.py)
ADD_PYTHON_TEST(PyQgsAnnotationPolygonItem test_qgsannotationpolygonitem.py)
ADD_PYTHON_TEST(PyQgsApplication test_qgsapplication.py)
ADD_PYTHON_TEST(PyQgsAttributeFormEditorWidget test_qgsattributeformeditorwidget.py)
ADD_PYTHON_TEST(PyQgsAttributeForm test_qgsattributeform.py)
ADD_PYTHON_TEST(PyQgsAttributeTableConfig test_qgsattributetableconfig.py)
ADD_PYTHON_TEST(PyQgsAttributeTableModel test_qgsattributetablemodel.py)
ADD_PYTHON_TEST(PyQgsAuthenticationSystem test_qgsauthsystem.py)
ADD_PYTHON_TEST(PyQgsAuthBasicMethod test_qgsauthbasicmethod.py)
ADD_PYTHON_TEST(PyQgsBabelGpsFormat test_qgsbabelgpsformat.py)
ADD_PYTHON_TEST(PyQgsBatchGeocodeAlgorithm test_qgsgeocoderalgorithm.py)
ADD_PYTHON_TEST(PyQgsBearingUtils test_qgsbearingutils.py)
ADD_PYTHON_TEST(PyQgsBinaryWidget test_qgsbinarywidget.py)
ADD_PYTHON_TEST(PyQgsBlendModes test_qgsblendmodes.py)
ADD_PYTHON_TEST(PyQgsBlockingProcess test_qgsblockingprocess.py)
ADD_PYTHON_TEST(PyQgsBlockingNetworkRequest test_qgsblockingnetworkrequest.py)
ADD_PYTHON_TEST(PyQgsBookmarkManager test_qgsbookmarkmanager.py)
ADD_PYTHON_TEST(PyQgsBookmarkModel test_qgsbookmarkmodel.py)
ADD_PYTHON_TEST(PyQgsBox3d test_qgsbox3d.py)
ADD_PYTHON_TEST(PyQgsCategorizedSymbolRenderer test_qgscategorizedsymbolrenderer.py)
ADD_PYTHON_TEST(PyQgsCheckableComboBox test_qgscheckablecombobox.py)
ADD_PYTHON_TEST(PyQgsClassificationMethod test_qgsclassificationmethod.py)
ADD_PYTHON_TEST(PyQgsCodeEditor test_qgscodeeditor.py)
ADD_PYTHON_TEST(PyQgsCodeEditorColorScheme test_qgscodeeditorcolorscheme.py)
ADD_PYTHON_TEST(PyQgsColorButton test_qgscolorbutton.py)
ADD_PYTHON_TEST(PyQgsColorRamp test_qgscolorramp.py)
ADD_PYTHON_TEST(PyQgsColorRampLegendNode test_qgscolorramplegendnode.py)
ADD_PYTHON_TEST(PyQgsColorScheme test_qgscolorscheme.py)
ADD_PYTHON_TEST(PyQgsColorSchemeRegistry test_qgscolorschemeregistry.py)
ADD_PYTHON_TEST(PyQgsCoordinateFormatter test_qgscoordinateformatter.py)
ADD_PYTHON_TEST(PyQgsCoordinateOperationWidget test_qgscoordinateoperationwidget.py)
ADD_PYTHON_TEST(PyQgsConditionalFormatWidgets test_qgsconditionalformatwidgets.py)
ADD_PYTHON_TEST(PyQgsConditionalStyle test_qgsconditionalstyle.py)
ADD_PYTHON_TEST(PyQgsConnectionRegistry test_qgsconnectionregistry.py)
ADD_PYTHON_TEST(PyQgsCoordinateTransformContext test_qgscoordinatetransformcontext.py)
ADD_PYTHON_TEST(PyQgsDefaultValue test_qgsdefaultvalue.py)
ADD_PYTHON_TEST(PyQgsXmlUtils test_qgsxmlutils.py)
ADD_PYTHON_TEST(PyQgsCore test_qgscore.py)
ADD_PYTHON_TEST(PyQgsCoordinateTransform test_qgscoordinatetransform.py)
ADD_PYTHON_TEST(PyQgsDataItem test_qgsdataitem.py)
ADD_PYTHON_TEST(PyQgsDataItemGuiProviderRegistry test_qgsdataitemguiproviderregistry.py)
ADD_PYTHON_TEST(PyQgsDataItemProviderRegistry test_qgsdataitemproviderregistry.py)
ADD_PYTHON_TEST(PyQgsDateTimeEdit test_qgsdatetimeedit.py)
ADD_PYTHON_TEST(PyQgsDateTimeStatisticalSummary test_qgsdatetimestatisticalsummary.py)
ADD_PYTHON_TEST(PyQgsDatumTransform test_qgsdatumtransforms.py)
ADD_PYTHON_TEST(PyQgsDelimitedTextProvider test_qgsdelimitedtextprovider.py)
ADD_PYTHON_TEST(PyQgsDistanceArea test_qgsdistancearea.py)
ADD_PYTHON_TEST(PyQgsEditFormConfig test_qgseditformconfig.py)
ADD_PYTHON_TEST(PyQgsEditWidgets test_qgseditwidgets.py)
ADD_PYTHON_TEST(PyQgsEllipsoidUtils test_qgsellipsoidutils.py)
ADD_PYTHON_TEST(PyQgsEmbeddedSymbolRenderer test_qgsembeddedsymbolrenderer.py)
ADD_PYTHON_TEST(PyQgsEncodingSelectionDialog test_qgsencodingselectiondialog.py)
ADD_PYTHON_TEST(PyQgsExifTools test_qgsexiftools.py)
ADD_PYTHON_TEST(PyQgsExpression test_qgsexpression.py)
ADD_PYTHON_TEST(PyQgsExpressionBuilderWidget test_qgsexpressionbuilderwidget.py)
ADD_PYTHON_TEST(PyQgsExpressionLineEdit test_qgsexpressionlineedit.py)
ADD_PYTHON_TEST(PyQgsExtentGroupBox test_qgsextentgroupbox.py)
ADD_PYTHON_TEST(PyQgsExtentWidget test_qgsextentwidget.py)
ADD_PYTHON_TEST(PyQgsExternalStorageWebDAV test_qgsexternalstorage_webdav.py)
ADD_PYTHON_TEST(PyQgsFeature test_qgsfeature.py)
ADD_PYTHON_TEST(PyQgsFeatureSink test_qgsfeaturesink.py)
ADD_PYTHON_TEST(PyQgsFeatureSource test_qgsfeaturesource.py)
ADD_PYTHON_TEST(PyQgsFieldComboBoxTest test_qgsfieldcombobox.py)
ADD_PYTHON_TEST(PyQgsFieldFormattersTest test_qgsfieldformatters.py)
ADD_PYTHON_TEST(PyQgsFillSymbolLayers test_qgsfillsymbollayers.py)
ADD_PYTHON_TEST(PyQgsProject test_qgsproject.py)
ADD_PYTHON_TEST(PyQgsProjectBadLayers test_qgsprojectbadlayers.py)
ADD_PYTHON_TEST(PyQgsProjectDisplaySettings test_qgsprojectdisplaysettings.py)
ADD_PYTHON_TEST(PyQgsProjectTimeSettings test_qgsprojecttimesettings.py)
ADD_PYTHON_TEST(PyQgsProjectViewSettings test_qgsprojectviewsettings.py)
ADD_PYTHON_TEST(PyQgsFeatureIterator test_qgsfeatureiterator.py)
ADD_PYTHON_TEST(PyQgsFeatureRequest test_qgsfeaturerequest.py)
ADD_PYTHON_TEST(PyQgsFeedback test_qgsfeedback.py)
ADD_PYTHON_TEST(PyQgsFields test_qgsfields.py)
ADD_PYTHON_TEST(PyQgsFieldModel test_qgsfieldmodel.py)
ADD_PYTHON_TEST(PyQgsFieldMappingWidget test_qgsfieldmappingwidget.py)
ADD_PYTHON_TEST(PyQgsFileUtils test_qgsfileutils.py)
ADD_PYTHON_TEST(PyQgsFilterLineEdit test_qgsfilterlineedit.py)
ADD_PYTHON_TEST(PyQgsFloatingWidget test_qgsfloatingwidget.py)
ADD_PYTHON_TEST(PyQgsFontButton test_qgsfontbutton.py)
ADD_PYTHON_TEST(PyQgsFontUtils test_qgsfontutils.py)
ADD_PYTHON_TEST(PyQgsGdalProvider test_provider_gdal.py)
ADD_PYTHON_TEST(PyQgsGeocoderLocatorFilter test_qgsgeocoderlocatorfilter.py)
ADD_PYTHON_TEST(PyQgsGeoNodeConnection test_qgsgeonodeconnection.py)
ADD_PYTHON_TEST(PyQgsGeometryAvoidIntersections test_qgsgeometry_avoid_intersections.py)
ADD_PYTHON_TEST(PyQgsGeometryGeneratorSymbolLayer test_qgsgeometrygeneratorsymbollayer.py)
ADD_PYTHON_TEST(PyQgsGeometryTest test_qgsgeometry.py)
ADD_PYTHON_TEST(PyQgsGeometryValidator test_qgsgeometryvalidator.py)
ADD_PYTHON_TEST(PyQgsNominatimGeocoder test_qgsnominatimgeocoder.py)
ADD_PYTHON_TEST(PyQgsGoogleMapsGeocoder test_qgsgooglemapsgeocoder.py)
ADD_PYTHON_TEST(PyQgsGpxProvider test_provider_gpx.py)
ADD_PYTHON_TEST(PyQgsGraduatedSymbolRenderer test_qgsgraduatedsymbolrenderer.py)
ADD_PYTHON_TEST(PyQgsHashLineSymbolLayer test_qgshashlinesymbollayer.py)
ADD_PYTHON_TEST(PyQgsHighlight test_qgshighlight.py)
ADD_PYTHON_TEST(PyQgsImageCache test_qgsimagecache.py)
ADD_PYTHON_TEST(PyQgsImageSourceLineEdit test_qgsimagesourcelineedit.py)
ADD_PYTHON_TEST(PyQgsInterpolatedLineSymbolLayer test_qgsinterpolatedlinesymbollayers.py)
ADD_PYTHON_TEST(PyQgsInterval test_qgsinterval.py)
ADD_PYTHON_TEST(PyQgsJsonEdit test_qgsjsonedit.py)
ADD_PYTHON_TEST(PyQgsJsonUtils test_qgsjsonutils.py)
ADD_PYTHON_TEST(PyQgsLabelLineSettings test_qgslabellinesettings.py)
ADD_PYTHON_TEST(PyQgsLabelObstacleSettings test_qgslabelobstaclesettings.py)
ADD_PYTHON_TEST(PyQgsLabelSettingsWidget test_qgslabelsettingswidget.py)
ADD_PYTHON_TEST(PyQgsLabelThinningSettings test_qgslabelthinningsettings.py)
ADD_PYTHON_TEST(PyQgsLayerMetadata test_qgslayermetadata.py)
ADD_PYTHON_TEST(PyQgsLayerTreeMapCanvasBridge test_qgslayertreemapcanvasbridge.py)
ADD_PYTHON_TEST(PyQgsLayerTree test_qgslayertree.py)
ADD_PYTHON_TEST(PyQgsLayerTreeView test_qgslayertreeview.py)
ADD_PYTHON_TEST(PyQgsLayout test_qgslayout.py)
ADD_PYTHON_TEST(PyQgsLayoutAlign test_qgslayoutaligner.py)
ADD_PYTHON_TEST(PyQgsLayoutAtlas test_qgslayoutatlas.py)
ADD_PYTHON_TEST(PyQgsLayoutComboBox test_qgslayoutcombobox.py)
ADD_PYTHON_TEST(PyQgsLayoutExporter test_qgslayoutexporter.py)
ADD_PYTHON_TEST(PyQgsLayoutFrame test_qgslayoutframe.py)
ADD_PYTHON_TEST(PyQgsLayoutManager test_qgslayoutmanager.py)
ADD_PYTHON_TEST(PyQgsLayoutManagerModel test_qgslayoutmanagermodel.py)
ADD_PYTHON_TEST(PyQgsLayoutPageCollection test_qgslayoutpagecollection.py)
ADD_PYTHON_TEST(PyQgsLayoutView test_qgslayoutview.py)
ADD_PYTHON_TEST(PyQgsLayoutGridSettings test_qgslayoutgridsettings.py)
ADD_PYTHON_TEST(PyQgsLayoutGuide test_qgslayoutguides.py)
ADD_PYTHON_TEST(PyQgsLayoutHtml test_qgslayouthtml.py)
ADD_PYTHON_TEST(PyQgsLayoutItem test_qgslayoutitem.py)
ADD_PYTHON_TEST(PyQgsLayoutItemComboBox test_qgslayoutitemcombobox.py)
ADD_PYTHON_TEST(PyQgsLayoutItemPropertiesDialog test_qgslayoutitempropertiesdialog.py)
ADD_PYTHON_TEST(PyQgsLayoutLabel test_qgslayoutlabel.py)
ADD_PYTHON_TEST(PyQgsLayoutLegend test_qgslayoutlegend.py)
ADD_PYTHON_TEST(PyQgsLayoutMap test_qgslayoutmap.py)
ADD_PYTHON_TEST(PyQgsLayoutItemMapAtlasClippingSettings test_qgslayoutatlasclippingsettings.py)
ADD_PYTHON_TEST(PyQgsLayoutItemMapItemClipPathSettings test_qgslayoutmapitemclippingsettings.py)
ADD_PYTHON_TEST(PyQgsLayoutMapGrid test_qgslayoutmapgrid.py)
ADD_PYTHON_TEST(PyQgsLayoutMapOverview test_qgslayoutmapoverview.py)
ADD_PYTHON_TEST(PyQgsLayoutMarker test_qgslayoutmarker.py)
ADD_PYTHON_TEST(PyQgsLayoutNorthArrowHandler test_qgslayoutnortharrowhandler.py)
ADD_PYTHON_TEST(PyQgsLayoutPage test_qgslayoutpage.py)
ADD_PYTHON_TEST(PyQgsLayoutPicture test_qgslayoutpicture.py)
ADD_PYTHON_TEST(PyQgsLayoutPolygon test_qgslayoutpolygon.py)
ADD_PYTHON_TEST(PyQgsLayoutPolyline test_qgslayoutpolyline.py)
ADD_PYTHON_TEST(PyQgsLayoutScaleBar test_qgslayoutscalebar.py)
ADD_PYTHON_TEST(PyQgsLayoutShape test_qgslayoutshape.py)
ADD_PYTHON_TEST(PyQgsLayoutSnapper test_qgslayoutsnapper.py)
ADD_PYTHON_TEST(PyQgsLayoutTable test_qgslayouttable.py)
ADD_PYTHON_TEST(PyQgsLayoutUnitsComboBox test_qgslayoutunitscombobox.py)
ADD_PYTHON_TEST(PyQgsLegendPatchShape test_qgslegendpatchshape.py)
ADD_PYTHON_TEST(PyQgsLegendPatchShapeButton test_qgslegendpatchshapebutton.py)
ADD_PYTHON_TEST(PyQgsLegendPatchShapeWidget test_qgslegendpatchshapewidget.py)
ADD_PYTHON_TEST(PyQgsLegendRenderer test_qgslegendrenderer.py)
ADD_PYTHON_TEST(PyQgsLineSegment test_qgslinesegment.py)
ADD_PYTHON_TEST(PyQgsLineSymbolLayers test_qgslinesymbollayers.py)
ADD_PYTHON_TEST(PyQgsLocalDefaultSettings test_qgslocaldefaultsettings.py)
ADD_PYTHON_TEST(PyQgsLocalizedDataPathRegistry test_qgslocalizeddatapathregistry.py)
ADD_PYTHON_TEST(PyQgsLocator test_qgslocator.py)
ADD_PYTHON_TEST(PyQgsMapBoxGlStyleConverter test_qgsmapboxglconverter.py)
ADD_PYTHON_TEST(PyQgsMapCanvas test_qgsmapcanvas.py)
ADD_PYTHON_TEST(PyQgsMapCanvasAnnotationItem test_qgsmapcanvasannotationitem.py)
ADD_PYTHON_TEST(PyQgsMapClippingRegion test_qgsmapclippingregion.py)
ADD_PYTHON_TEST(PyQgsMapClippingUtils test_qgsmapclippingutils.py)
ADD_PYTHON_TEST(PyQgsMapLayer test_qgsmaplayer.py)
ADD_PYTHON_TEST(PyQgsMapLayerAction test_qgsmaplayeraction.py)
ADD_PYTHON_TEST(PyQgsMapLayerComboBox test_qgsmaplayercombobox.py)
ADD_PYTHON_TEST(PyQgsMapLayerFactory test_qgsmaplayerfactory.py)
ADD_PYTHON_TEST(PyQgsMapLayerModel test_qgsmaplayermodel.py)

=== debian/changelog ===
qgis (3.22.10+dfsg-1build1) kinetic; urgency=medium

  * No-change rebuild against Qt 5.15.6.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Sun, 18 Sep 2022 10:53:11 +0300

qgis (3.22.10+dfsg-1) unstable; urgency=medium

  * Update symbols for other architectures.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 16 Aug 2022 07:20:17 +0200

qgis (3.22.10+dfsg-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Update symbols for amd64.
  * Update lintian overrides.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 12 Aug 2022 14:33:22 +0200

qgis (3.22.9+dfsg-1) unstable; urgency=medium

  * Update symbols for other architectures.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 17 Jul 2022 12:16:10 +0200

qgis (3.22.9+dfsg-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Drop obsolete dh_strip override, dbgsym migration complete.
  * Refresh patches.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 15 Jul 2022 15:24:50 +0200

qgis (3.22.8+dfsg-1) unstable; urgency=medium

  * Bump Standards-Version to 4.6.1, no changes.
  * Update symbols for other architectures.
  * Update lintian overrides.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 23 Jun 2022 15:02:34 +0200

qgis (3.22.8+dfsg-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Update copyright file.
  * Refresh patches.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 17 Jun 2022 17:10:23 +0200

qgis (3.22.7+dfsg-2) unstable; urgency=medium

  * Update packaging for GRASS 8.2.0.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 04 Jun 2022 12:59:14 +0200

qgis (3.22.7+dfsg-1) unstable; urgency=medium

  * Update symbols for other architectures.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 21 May 2022 10:45:59 +0200

qgis (3.22.7+dfsg-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Add patch to fix FTBFS with GDAL 3.5.0.
  * Bump minimum GRASS build dependency version to 8.0.2.
  * Refresh patches.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 15 May 2022 20:04:42 +0200

qgis (3.22.6+dfsg-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Drop grass8.patch, applied upstream. Refresh remaining patches.
  * Update copyright file.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 15 Apr 2022 18:40:47 +0200

qgis (3.22.5+dfsg-1) unstable; urgency=medium

  * Update symbols for other architectures.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 20 Mar 2022 07:17:20 +0100

qgis (3.22.5+dfsg-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Update copyright file.
  * Update packaging for GRASS 8.0.1.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 18 Mar 2022 14:35:36 +0100

=== debian/control ===
Source: qgis
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Francesco Paolo Lovergine <frankie@debian.org>,
           Bas Couwenberg <sebastic@debian.org>
Section: science
Priority: optional
Build-Depends: bison,
               ca-certificates,
               cmake,
               debhelper-compat (= 12),
               dh-python,
               flex,
               gdal-bin,
               grass-dev (>= 8.2.0),
               libexiv2-dev,
               libexpat1-dev,
               libfcgi-dev,
               libgdal-dev (>= 1.11),
               libgeos-dev (>= 3.0.0),
               libgsl-dev,
               libpq-dev,
               libproj-dev,
               libprotobuf-dev,
               libqca-qt5-2-dev,
               libqca-qt5-2-plugins,
               libqscintilla2-qt5-dev,
               libqt5opengl5-dev,
               libqt5serialport5-dev,
               libqt5sql5-sqlite,
               libqt5svg5-dev,
               libqt5webkit5-dev,
               libqt5xmlpatterns5-dev,
               libqwt-qt5-dev,
               libspatialindex-dev,
               libspatialite-dev,
               libsqlite3-dev,
               libsqlite3-mod-spatialite,
               libzip-dev,
               libzstd-dev,
               ninja-build,
               ocl-icd-opencl-dev,
               opencl-headers,
               pkg-config,
               protobuf-compiler,
               pyqt5-dev-tools,
               pyqt5-dev,
               pyqt5.qsci-dev,
               python3-dev,
               python3-future,
               python3-gdal,
               python3-mock,
               python3-nose2,
               python3-owslib,
               python3-psycopg2,
               python3-pyqt5,
               python3-pyqt5.qsci,
               python3-pyqt5.qtpositioning,
               python3-pyqt5.qtsql,
               python3-pyqt5.qtsvg,
               python3-pyqtbuild,
               python3-sipbuild,
               python3-termcolor,
               python3-yaml,
               qt3d5-dev,
               qt3d-assimpsceneimport-plugin,
               qt3d-defaultgeometryloader-plugin,
               qt3d-gltfsceneio-plugin,
               qt3d-scene2d-plugin,
               qt5keychain-dev,
               qtbase5-dev,
               qtbase5-private-dev,
               qtpositioning5-dev,
               qttools5-dev-tools,
               qttools5-dev,
               sip-tools,
               git,
               doxygen,
               graphviz,
               xvfb,
               xauth,
               xfonts-base,
               xfonts-100dpi,
               xfonts-75dpi,
               xfonts-scalable,
               spawn-fcgi,
               poppler-utils,
               locales,
               pkg-kde-tools
Build-Conflicts: libqgis-dev,
                 qgis-dev
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/debian-gis-team/qgis
Vcs-Git: https://salsa.debian.org/debian-gis-team/qgis.git
Homepage: https://qgis.org/

Package: qgis
Architecture: any
Depends: python3-qgis (= ${binary:Version}),
         qgis-common (= ${source:Version}),
         qgis-providers (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Recommends: qgis-plugin-grass
Suggests: gpsbabel
Breaks: qgis-common (<< 3.4.5),
        qgis-provider-grass (<< 2.14.0)
Conflicts: uim-qt3
Replaces: qgis-common (<< 3.4.5),
          qgis-provider-grass (<< 2.14.0)
Description: Geographic Information System (GIS)
 A Geographic Information System (GIS) manages, analyzes, and displays
 databases of geographic information. QGIS supports shape file viewing and
 editing, spatial data storage with PostgreSQL/PostGIS, projection on-the-fly,
 map composition, and a number of other features via a plugin interface. QGIS
 also supports display of various georeferenced raster and Digital Elevation
 Model (DEM) formats including GeoTIFF, Arc/Info ASCII Grid, and USGS ASCII
 DEM.

Package: qgis-common
Architecture: all
Depends: libjs-jquery,
         libjs-leaflet,
         qml-module-qtcharts,
         ${misc:Depends}
Breaks: qgis (<< 2.18.17)
Replaces: qgis (<< 2.18.17)
Description: QGIS - architecture-independent data
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This package contains architecture-independent supporting data files for use
 with QGIS.

Package: libqgis-3d3.22.10
Architecture: any
Section: libs
Depends: qt3d-assimpsceneimport-plugin,
         qt3d-defaultgeometryloader-plugin,
         qt3d-gltfsceneio-plugin,
         qt3d-scene2d-plugin,
         ${shlibs:Depends},
         ${misc:Depends}
Description: QGIS - shared 3d library
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This package contains the shared 3d library.

Package: libqgis-analysis3.22.10
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: QGIS - shared analysis library
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This package contains the shared analysis library.

Package: libqgis-app3.22.10
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: QGIS - shared app library
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This package contains the shared app library.

Package: libqgis-core3.22.10
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: QGIS - shared core library
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This package contains the shared core library.

Package: libqgis-gui3.22.10
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: QGIS - shared gui library
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This package contains the shared gui library.

Package: libqgis-native3.22.10
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: QGIS - shared native gui library
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This package contains the shared native gui library.

Package: libqgis-server3.22.10
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: QGIS - shared server library
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This package contains the shared server library.

Package: libqgisgrass8-3.22.10
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: QGIS - shared grass library
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This package contains the shared grass library.

Package: libqgispython3.22.10
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: QGIS - shared Python library
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This package contains the shared Python library.

Package: libqgis-customwidgets
Architecture: any
Depends: qttools5-dev-tools,
         ${shlibs:Depends},
         ${misc:Depends}
Description: QGIS custom widgets for Qt Designer
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This package contains a library to use specific QGIS widgets in Qt Designer.

Package: libqgis-dev
Architecture: any
Section: libdevel
Depends: grass-dev (>= 8.2.0),
         libexiv2-dev,
         libexpat1-dev,
         libgdal-dev (>= 1.11),
         libgeos-dev (>= 3.0.0),
         libgsl-dev,
         libpq-dev,
         libproj-dev,
         libqca-qt5-2-dev,
         libqgis-3d3.22.10 (= ${binary:Version}),
         libqgis-analysis3.22.10 (= ${binary:Version}),
         libqgis-app3.22.10 (= ${binary:Version}),
         libqgis-core3.22.10 (= ${binary:Version}),
         libqgis-gui3.22.10 (= ${binary:Version}),
         libqgis-native3.22.10 (= ${binary:Version}),
         libqgis-server3.22.10 (= ${binary:Version}),
         libqgisgrass8-3.22.10 (= ${binary:Version}),
         libqgispython3.22.10 (= ${binary:Version}),
         libqscintilla2-qt5-dev,
         libqt5svg5-dev,
         libqt5webkit5-dev,
         libqwt-qt5-dev,
         libsqlite3-dev,
         pyqt5-dev-tools,
         pyqt5.qsci-dev,
         python3-dev,
         python3-pyqt5,
         python3-pyqt5.qsci,
         python3-pyqt5.qtsql,
         python3-pyqt5.sip,
         python3-pyqtbuild,
         qgis-sip (= ${source:Version}),
         qtbase5-dev,
         qtpositioning5-dev,
         qttools5-dev,
         sip-tools,
         ${misc:Depends}
Recommends: libqgis-customwidgets
Provides: qgis-dev
Replaces: libqgis1-dev
Description: QGIS - development files
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This package contains the headers and libraries needed to develop plugins for
 QGIS.

Package: qgis-sip
Architecture: all
Section: devel
Depends: ${misc:Depends}
Description: SIP specification files for QGIS
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This package contains the SIP specification files.

Package: qgis-provider-grass
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: GRASS provider for QGIS
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This provider enables GRASS data access in QGIS.

Package: qgis-plugin-grass
Architecture: any
Depends: qgis (= ${binary:Version}),
         qgis-plugin-grass-common (= ${source:Version}),
         qgis-provider-grass (= ${binary:Version}),
         grass-core (>= 8.2.0),
         ${grass:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Breaks: qgis-provider-grass (<< 2.11.0+git20151002)
Replaces: qgis-provider-grass (<< 2.11.0+git20151002)
Description: GRASS plugin for QGIS
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This plugin enables GRASS data access in QGIS.

Package: qgis-plugin-grass-common
Architecture: all
Depends: ${python3:Depends},
         ${misc:Depends}
Breaks: qgis-common (<< 1.5)
Replaces: qgis-common (<< 1.5)
Description: GRASS plugin for QGIS - architecture-independent data
 QGIS is a Geographic Information System (GIS) which manages, analyzes and
 display databases of geographic information.
 .
 This package contains architecture-independent supporting data files for use
 with the QGIS GRASS plugin.

Package: python3-qgis
Architecture: any
Section: python
Depends: python3-qgis-common (= ${source:Version}),
         qgis-providers (= ${binary:Version}),
         libqgispython3.22.10,
         libsqlite3-mod-spatialite,
         python3-dateutil,
         python3-future,
         python3-httplib2,
         python3-jinja2,
         python3-lxml,
         python3-markupsafe,
         python3-owslib,
         python3-plotly,
         python3-psycopg2,
         python3-pygments,
         python3-pyproj,
         python3-pyqt5,
         python3-pyqt5.qsci,
         python3-pyqt5.qtpositioning,
         python3-pyqt5.qtsql,
         python3-pyqt5.qtsvg,
         python3-pyqt5.qtwebkit,
         python3-requests,
         python3-six,
         python3-tz,

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

include /usr/share/dpkg/pkg-info.mk

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_BUILD_ARCH      ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
DEB_BUILD_MULTIARCH ?= $(shell dpkg-architecture -qDEB_BUILD_MULTIARCH)

DEB_TEST_TARGET ?= Experimental

QGIS_BUILDDIR ?= debian/build

export QT_SELECT=5

QGIS_VERSION=$(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+.*//')

ifeq (,$(DIST))
	DISTRIBUTION := $(DEB_DISTRIBUTION)
else
	DISTRIBUTION := $(DIST)
endif

ifneq (,$(findstring -oracle,$(DISTRIBUTION)))
	DISTRIBUTION := $(subst -oracle,,$(DISTRIBUTION))
	WITH_ORACLE=1
endif

QT_PLUGINS_DIR = lib/$(DEB_BUILD_MULTIARCH)/qt5/plugins

ifneq ($(DISTRIBUTION),$(findstring $(DISTRIBUTION),"buster bullseye bionic focal"))
	DISTRIBUTION := sid
endif

DEB_BUILD_NAME ?= $(DISTRIBUTION)-$(DEB_BUILD_ARCH)

# Don't build tests, running them requires network
DEB_BUILD_OPTIONS += nocheck

QGIS_MAJOR=$(shell sed -ne 's/SET(CPACK_PACKAGE_VERSION_MAJOR "\([0-9]*\)")/\1/ip' CMakeLists.txt)
QGIS_MINOR=$(shell sed -ne 's/SET(CPACK_PACKAGE_VERSION_MINOR "\([0-9]*\)")/\1/ip' CMakeLists.txt)
QGIS_PATCH=$(shell sed -ne 's/SET(CPACK_PACKAGE_VERSION_PATCH "\([0-9]*\)")/\1/ip' CMakeLists.txt)
QGIS_ABI=$(QGIS_MAJOR).$(QGIS_MINOR).$(QGIS_PATCH)
GRASS=grass$(subst .,,$(shell pkg-config --modversion grass|cut -d. -f1,2))
GRASSVER=$(subst .,,$(shell pkg-config --modversion grass|cut -d. -f1))
GRASSABI=$(subst .,,$(shell pkg-config --modversion grass|cut -d. -f1,2,3|sed -e 's/RC/-/'))

PYTHON_GE_38=$(shell python3 -c 'import sys; print(1) if(sys.version_info[0] > 3 or (sys.version_info[0] == 3 and sys.version_info[1] >= 8)) else print(0)')

# Include percentage of started edges
export NINJA_STATUS=[%f/%t %p]

ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
	NINJA_OPTS += -v
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
	NINJA_OPTS += -j$(NUMJOBS)
endif

ifeq (,$(DISPLAY))
TESTMAKE=xvfb-run -a -n 1 -s "-screen 0 1280x1024x24 -dpi 96" ninja $(NINJA_OPTS)
else
TESTMAKE=ninja $(NINJA_OPTS)
endif

CMAKE_OPTS := \
	-G Ninja \
	-DBUILDNAME=$(DEB_BUILD_NAME) \
	-DCMAKE_VERBOSE_MAKEFILE=1 \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DBINDINGS_GLOBAL_INSTALL=TRUE \
	-DSIP_GLOBAL_INSTALL=TRUE \
	-DPEDANTIC=TRUE \
	-DSERVER_SKIP_ECW=TRUE \
	-DQGIS_CGIBIN_SUBDIR=/usr/lib/cgi-bin \
	-DWITH_APIDOC=TRUE \
	-DGENERATE_QHP=TRUE \
	-DWITH_CUSTOM_WIDGETS=TRUE \
	-DWITH_SERVER=TRUE \
	-DWITH_SERVER_PLUGINS=TRUE \
	-DWITH_QSPATIALITE=TRUE \
	-DWITH_QWTPOLAR=FALSE \
	-DWITH_3D=TRUE \
	-DGEOS_LIBRARY=/usr/lib/$(DEB_BUILD_MULTIARCH)/libgeos_c.so \
	-DWITH_HANA=TRUE \
	-DWITH_EPT=TRUE \
	-DQT_PLUGINS_DIR=$(QT_PLUGINS_DIR)


ifeq ($(PYTHON_GE_38),1)
	CMAKE_OPTS += -DPYTHON_LIBRARY=$(shell python3-config --ldflags --embed | sed -e 's@-L\(.*\) -L[^ ]* -l\([^ ]*\) .*$$@\1/lib\2.so@')
else
	CMAKE_OPTS += -DPYTHON_LIBRARY=$(shell python3-config --ldflags | sed -e 's@-L\(.*\) -L/usr/lib -l\([^ ]*\) .*$$@\1/lib\2.so@')
endif

ifneq ($(SHA),)
	CMAKE_OPTS += -DSHA=$(SHA)
endif

ifneq (,$(findstring ;$(GRASSVER);, ";7;8;"))
	CMAKE_OPTS += \
		-DWITH_GRASS=TRUE \
		-DWITH_GRASS$(GRASSVER)=TRUE \
		-DGRASS_PREFIX$(GRASSVER)=/usr/lib/$(GRASS)
endif

ifneq (,$(findstring $(DISTRIBUTION),"sid buster"))
	CMAKE_OPTS += -DPOSTGRES_LIBRARY=/usr/lib/$(DEB_BUILD_MULTIARCH)/libpq.so
endif

$(shell test -f /usr/include/$(DEB_BUILD_MULTIARCH)/qt5/Qt3DExtras/qt3dextrasversion.h -a -f /usr/lib/$(DEB_BUILD_MULTIARCH)/cmake/Qt53DExtras/Qt53DExtrasConfig.cmake)
ifneq (0,$(.SHELLSTATUS))
# Qt3DExtras intentionally removed from debian (#895386) and in turn ubuntu
	CMAKE_OPTS += \
		-DQt53DExtras_DIR=$(realpath external/qt3dextra-headers/cmake/Qt53DExtras) \
		-DQT5_3DEXTRA_INCLUDE_DIR=$(realpath external/qt3dextra-headers) \
		-DQT5_3DEXTRA_LIBRARY=/usr/lib/$(DEB_BUILD_MULTIARCH)/libQt53DExtras.so
endif

ifneq (,$(WITH_ORACLE))
ifeq ($(DEB_BUILD_ARCH),amd64)
	ORACLE_INCLUDEDIR=/usr/include/oracle/18.5/client64/
	ORACLE_LIBDIR=/usr/lib/oracle/18.5/client64/lib/
endif
ifeq ($(DEB_BUILD_ARCH),i386)
	ORACLE_INCLUDEDIR=/usr/include/oracle/18.5/client/
	ORACLE_LIBDIR=/usr/lib/oracle/18.5/client/lib/
endif
	CMAKE_OPTS += \
		-DWITH_ORACLE=TRUE \
		-DORACLE_LIBDIR=$(ORACLE_LIBDIR) \
		-DORACLE_INCLUDEDIR=$(ORACLE_INCLUDEDIR)
endif

ifneq (,$(findstring $(DISTRIBUTION),"sid buster"))
	CMAKE_OPTS += -DSPATIALINDEX_LIBRARY=/usr/lib/$(DEB_BUILD_MULTIARCH)/libspatialindex.so
endif

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CMAKE_OPTS += -DCMAKE_BUILD_TYPE=Debug
endif

ifneq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	CMAKE_OPTS += -DENABLE_TESTS=FALSE
else
	CMAKE_OPTS += -DENABLE_TESTS=TRUE -DDART_TESTING_TIMEOUT=60
endif

CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS   := $(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
CXXFLAGS := $(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
LDFLAGS  := $(shell dpkg-buildflags --get LDFLAGS)

ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
	CXXFLAGS += -O0
else
	CFLAGS += -O2
	CXXFLAGS += -O2
endif

ifneq (,$(findstring profile,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -pg
	CXXFLAGS += -pg
	LDFLAGS += -pg
endif

ifeq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -DNDEBUG
	CXXFLAGS += -DNDEBUG
endif

ifeq ($(DEB_BUILD_ARCH),mips64el)
	CXXFLAGS += -mxgot
endif

%:
	dh $@ --with pkgkde_symbolshelper,python3 --builddirectory=$(QGIS_BUILDDIR)

override_dh_clean:
	dh_clean qgis.bin.1

	-$(RM) -r $(CURDIR)/$(QGIS_BUILDDIR)/

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_OPTS)

override_dh_auto_build:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	ninja $(NINJA_OPTS) -C $(QGIS_BUILDDIR) $(DEB_TEST_TARGET)Build
	! grep -q "<Error>" $(QGIS_BUILDDIR)/Testing/$$(head -1 $(QGIS_BUILDDIR)/Testing/TAG)/Build.xml || { \
		cat $(QGIS_BUILDDIR)/Testing/Temporary/LastBuild_$$(head -1 $(QGIS_BUILDDIR)/Testing/TAG).log; \
		ninja $(NINJA_OPTS) -C $(QGIS_BUILDDIR) $(DEB_TEST_TARGET)Submit; \
		false; }
else
	ninja $(NINJA_OPTS) -C $(QGIS_BUILDDIR)
endif

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# Code to run the package test suite
	rm -f $(QGIS_BUILDDIR)/.error
	mkdir -p debian/tmp/locale/
	localedef -f UTF-8 -i en_US ./debian/tmp/locale/en_US.UTF-8/
	LOCPATH=$(CURDIR)/debian/tmp/locale/ \
	LC_ALL=en_US.UTF-8 \
	LD_LIBRARY_PATH=$(CURDIR)/$(QGIS_BUILDDIR)/output/lib:$(LD_LIBRARY_PATH) \
	PATH=/usr/sbin:$(PATH) \
		$(TESTMAKE) -C $(QGIS_BUILDDIR) $(DEB_TEST_TARGET)Test || touch $(QGIS_BUILDDIR)/.error
	# ignore submission errors
	-$(TESTMAKE) -C $(QGIS_BUILDDIR) $(DEB_TEST_TARGET)Submit
	# ignore the test outcome for now
	# ! [ -f $(QGIS_BUILDDIR)/.error ]
else
	@echo Skipping tests.
endif

override_dh_auto_install:
	DESTDIR=$(CURDIR)/debian/tmp ninja $(NINJA_OPTS) -C $(QGIS_BUILDDIR) install

	# remove unwanted files
	$(RM) $(CURDIR)/debian/tmp/usr/share/qgis/doc/api/installdox

	# Don't include a copy of the world.tif also included in osgearth-data
	$(RM) $(CURDIR)/debian/tmp/usr/share/qgis/globe/world.tif

	# remove extra license files
	-find $(CURDIR)/debian/tmp/usr/share/qgis/resources/cpt-city-qgis-min/ -name COPYING.xml -delete
	$(RM) $(CURDIR)/debian/tmp/usr/share/qgis/doc/LICENSE
	$(RM) $(CURDIR)/debian/tmp/usr/share/qgis/python/plugins/db_manager/LICENSE
	$(RM) $(CURDIR)/debian/tmp/usr/share/qgis/python/plugins/MetaSearch/LICENSE.txt
